// タスクデータを作ろう
const tasks = [
  { id: 1, name: "部屋の後片付け" },
  { id: 2, name: "お買い物" },
]

// タスクデータをDOMに追加しよう

// template要素を取得する
const template = document.getElementById('taskTemplate')

// DOMを追加するための要素を取得する
const tbody = document.getElementById("tasks")

// タスクデータを一つずつループさせる
tasks.forEach((t) => {
  // template要素をコピーする
  const clone = template.content.cloneNode(true)

  // HTMLを取得する
  const tr = clone.querySelector("tr")
  const name = clone.querySelector(".name")

  // trタグにid属性を追加する
  tr.setAttribute("id", t.id)

  // タスク名を変更する
  name.textContent = t.name

  // タスクを削除しよう
  // clickイベントを設定しよう
  const deleteButton = clone.querySelector(".delete")
  deleteButton.addEventListener("click", () => {
    const target = document.getElementById(t.id)
    tbody.removeChild(target)

    document.removeEventListener("click", deleteButton)
  })

  // DOMに追加する
  tbody.appendChild(clone)
})

// タスクを追加しよう

// イベントハンドラを設定しよう
const form = document.getElementById('form')
form.addEventListener("submit", (event) => {
  // デフォルトの処理をキャンセルする
  event.preventDefault()

  // 入力されたデータを取得しよう
  const input = document.getElementById('input')
  const value = input.value

  if (!value) return

  // 新しいタスクデータを作る
  const task = { id: tasks.length + 1, name: value }

  // 入力した内容をToDoリストに追加する
  const clone = template.content.cloneNode(true)
  const tr = clone.querySelector("tr")
  const name = clone.querySelector(".name")

  tr.setAttribute("id", task.id)
  name.textContent = task.name

  const deleteButton = clone.querySelector(".delete")
  deleteButton.addEventListener("click", () => {
    const target = document.getElementById(task.id)
    tbody.removeChild(target)

    document.removeEventListener("click", deleteButton)
  })

  tbody.appendChild(clone)
})

// 全てのタスクを削除しよう
const deleteAllButton = document.getElementById("deleteAll")

deleteAllButton.addEventListener("click", () => {
  const tbody = document.getElementById("tasks")
  tbody.innerHTML = ""
})
