const tasks = [
  { id: 1, name: "部屋の後片付け" },
  { id: 2, name: "お買い物" },
]

const template = document.getElementById('taskTemplate')
const tbody = document.getElementById("tasks")

// タスクを削除する関数を定義しよう
const addDeleteListener = (tbody, button, id) => {
  button.addEventListener("click", () => {
    const target = document.getElementById(id)
    tbody.removeChild(target)

    document.removeEventListener("click", button)
  })
}

// タスクを追加する関数を定義しよう
const addTask = (tbody, task) => {
  const clone = template.content.cloneNode(true)
  const tr = clone.querySelector("tr")
  const name = clone.querySelector(".name")
  const deleteButton = clone.querySelector(".delete")

  tr.setAttribute("id", task.id)
  name.textContent = task.name

  // タスクを削除する
  addDeleteListener(tbody, deleteButton, task.id)

  tbody.appendChild(clone)
}

tasks.forEach((t) => {
  addTask(tbody, t)
})

const form = document.getElementById('form')
form.addEventListener("submit", (event) => {
  event.preventDefault()

  const input = document.getElementById('input')
  const value = input.value

  if (!value) return

  const task = { id: tasks.length + 1, name: value }
  addTask(tbody, task)
})

const deleteAllButton = document.getElementById("deleteAll")
deleteAllButton.addEventListener("click", () => {
  const tbody = document.getElementById("tasks")
  tbody.innerHTML = ""
})
